import React from 'react';
import { Text } from 'react-native';
export const HighlighterX = ({
  text,
  rules,
  customContainerStyle,
  customTextStyle,
  nonMatchTextStyle
}) => {
  const renderTextWithRules = (text, rules) => text && text.split(/\r?\n/).map((line, index) => /*#__PURE__*/React.createElement(Text, {
    key: index
  }, renderWordsWithRules(line, rules), /*#__PURE__*/React.createElement(Text, null, "\n")));
  const renderWordsWithRules = (row, rules) => {
    return row.split(/(\s+)/).map((word, index) => {
      const {
        style,
        onPress,
        onLongPress
      } = getMatchingRule(word, rules) || {};
      const handlePress = onPress ? () => onPress(word) : undefined;
      const handleLongPress = onLongPress ? () => onLongPress(word) : undefined;
      return /*#__PURE__*/React.createElement(Text, {
        key: index,
        style: [style || nonMatchTextStyle, customTextStyle],
        onPress: handlePress,
        onLongPress: handleLongPress
      }, word);
    });
  };
  const getMatchingRule = (word, rules) => {
    for (const rule of rules) {
      const {
        pattern,
        style,
        onPress,
        onLongPress
      } = rule;
      if (word.match(pattern)) {
        return {
          style,
          onPress,
          onLongPress
        };
      }
    }
    return null;
  };
  return /*#__PURE__*/React.createElement(Text, {
    style: customContainerStyle
  }, renderTextWithRules(text, rules));
};
export default HighlighterX;
//# sourceMappingURL=index.js.map